﻿--[[
--                                           MOUNTY ©2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables
--------------------------------------------------------------------------------------------------------------------------------
local Speed = {
	["Apprentice"] = {
		["ride"] = 160;
		["fly"] = 0;
		["available"] = 20;
	};
	["Journeyman"] = {
		["ride"] = 200;
		["fly"] = 0;
		["available"] = 40;
	};
	["Expert"] = {
		["ride"] = 200;
		["fly"] = 250;
		["available"] = 60;
	};
	["Artisan"] = {
		["ride"] = 200;
		["fly"] = 380;
		["available"] = 70;
	};
	["Master"] = {
		["ride"] = 200;
		["fly"] = 410;
		["available"] = 80;
	};
	["License"] = {
		["available"] = 60;
	};
	["Cold"] = {
		["available"] = 68;
	};
	["WFW"] = {
		["available"] = 90;
	};
};

function Mounty_ResetAbility()
	Ability = {}
	Ability["Ride"] = false;
	Ability["Fly"] = false;
	Ability["Vashj"] = false;
	
	Ability["Location"] = {
		["Unknown"] = false;
		["Kalimdor"] = false;
		["Eastern"] = false;
		["Outland"] = false;
		["Northrend"] = false;
		["Maelstrom"] = false;
		["Pandaria"] = false;
		["Draenor"] = false;
	};
	Ability["Skill"] = {
		["Special"] = false;
		["Apprentice"] = false;
		["Journeyman"] = false;
		["Expert"] = false;
		["Artisan"] = false;
		["Master"] = false;
		["License"] = false;
		["Cold"] = false;
		["WFW"] = false;
		["MountUp"] = false;
		["Stables"] = false;
	};
	Ability["printout"] = {
		["Apprentice"] = true;
		["Journeyman"] = true;
		["Expert"] = true;
		["Artisan"] = true;
		["Master"] = true;
		["License"] = true;
		["Cold"] = true;
		["WFW"] = true;
		["MountUp"] = true;
		["Stables"] = 0;
	};
	Ability["Mount"] = {
		["mounts"] = 0;
--		["active"] = 0;
		["name"] = {
			["ride"] = MOUNTYNOTSET;
			["shiftride"] = MOUNTYNOTSET;
			["fly"] = MOUNTYNOTSET;
			["shiftfly"] = MOUNTYNOTSET;
		};
	};
	return Ability;
end
local Ability = Mounty_ResetAbility();


local Continent = "Unknown";

local Vashj = {
	["name"] = "Unknown";
	["coord"] = 0;
};

local Flyable = false;

local State = {
	["IsMounted"] = false;
	["IsFlying"] = false;
}

local Macro = {
	["SAVE"] = 1;
	["MAXGEN"] = 120;
	["MAXCHAR"] = 18;
	["FIRSTGEN"] = 1;
	["FIRSTCHAR"] = 16777217;
	["LASTGEN"] = 18;
	["LASTCHAR"] = 16777234;
	["NAME"] = "          ";
	["iconTexture"] = "Interface\\Icons\\INV_Misc_QuestionMark";

	["Index"] = 0;
	["ID"] = 0;
	["perChar"] = false;
	["GENSPACE"] = false;
	["CHARSPACE"] = false;
	["iconNum"] = 1;
	["noflyzone"] = false;
	["rewrite"] = true;
	["safeflytxt"] = MOUNTY_SAFEFLY;
	["flyable"] = false;
	["combatflag"] = false;
	["Using"] = false;
	["Writing"] = false;
};

local Button = {
	[1] = "LeftButton";
	[2] = "RightButton";
	[3] = "MiddleButton";
	[4] = "Button4";
	[5] = "Button5";
	[6] = "Button6";
	[7] = "Button7";
	[8] = "Button8";
	[9] = "Button9";
	["LeftButton"] = 1;
	["RightButton"] = 2;
	["MiddleButton"] = 3;
	["Button4"] = 4;
	["Button5"] = 5;
	["Button6"] = 6;
	["Button7"] = 7;
	["Button8"] = 8;
	["Button9"] = 9;
	["Modifier"] = "nomod";
	["modNim"] = 0;
	["nomod"] = true;
	["Shift"] = false;
	["Ctrl"] = false;
	["Alt"] = false;
}

local Wintergrasp = {
	["Flag"] = false;
	["Timer"] = true;
}

local FirstUse = true;
local isSwimmingFlag = false;
local PrintHead = "|cff00ffff---------------<Mounty>----------------|r"
local PrintLine = "|cff00ffff---------------------------------------|r";
local INIT = true;
local DEFMOUNT = true;

--------------------------------------------------------------------------------------------------------------------------------
-- Initialization
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_InitializeVar()
	Mounty["Player"] = UnitName("player");
	Mounty["Faction"] = UnitFactionGroup("player");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMounty Faction"..Mounty["Faction"].."|r");
	Mounty["Realm"] = GetRealmName();
	Mounty["RealmID"] = string.gsub(Mounty["Realm"], " ", "");
	Mounty["RealmAbb"] = string.sub(Mounty.RealmID, 1, 3);
	Mounty["PlayerID"] = Mounty["Player"].."-"..Mounty["RealmID"];
	Mounty["ChatID"] = Mounty.Player.."-"..Mounty.RealmAbb;
	Mounty["ID"] = Mounty["PlayerID"].."-"..Mounty["Faction"];
	Mounty["Class"], Mounty["ClassFileName"] = 	UnitClass("player");
	Mounty["ClassColor"] = RAID_CLASS_COLORS[Mounty.ClassFileName];
	Mounty["PlayerColor"] = "|c"..Mounty.ClassColor.colorStr..Mounty.Player.."|r";
	Mounty["PlayerClassColor"] = "|c"..Mounty.ClassColor.colorStr..Mounty.Class.."|r";
	MOUNTYLOADED = true;
	MOUNTY.Owned = Mounty_SetOwnedList();
	Ability.Mount.mounts = MOUNTY.Owned[Mounty.Faction][0];
	Mounty_CheckDefaultMount();
	Mounty_SetMap();
	Mounty_GetMapZone();


	if not (MOUNTY_VERSION == Mounty.Version) then Mounty_ResetVersion(true); Mounty_InitializeVar(); end
	INIT = false;
end

function Mounty_SetAll()
	if INIT then Mounty_InitializeVar();end
	Mounty_SetMountID();
--	Mounty_VashjCheck();
	Mounty_SetFlyable();
	if Mounty_SetEnable()then
		if not (MOUNTY_VERSION == Mounty.Version) then Mounty_ResetVersion(true);end
--		Mounty_SetMountID();
--		Mounty_VashjCheck();
--		Mounty_SetFlyable();
		Mounty_WriteMacro(true);		
		Ability = Mounty_Stables(Ability);
	end
end

function Mounty_ResetVersion(forcereset)
	local reset = false;
	if forcereset then
		reset = true;
	end
	if not Mounty.Version then
		Mounty["Version"] = "0.0.0.0.0";
	end
	if not (MOUNTY_VERSION == Mounty.Version) then
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mounty Version Conflict.|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMounty v"..MOUNTY_VERSION.."|r");
		reset = true;
	end
	local fly, shiftfly, ride, shiftride, middle, shiftmiddle = MOUNTYNOTSET, MOUNTYNOTSET, MOUNTYNOTSET, MOUNTYNOTSET, MOUNTYNOTSET, MOUNTYNOTSET;
	local pchar = Mounty.perChar;
	local safe = Mounty.SafeFly;
	local enabled = Mounty.Enabled;
---- Add conversion blocks here: (Gather current settings)
---- Block #01 v3.3.5.1.0 - 4.0.1.1.0
	if Mounty.Ride.Text then
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting OLD Ride Mount|r");
		ride = Mounty.Ride.Text;
	end
	if Mounty.Fly.Text then
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting OLD Fly Mount|r");
		fly = Mounty.Fly.Text;
	end
---- Block #02 v4.0.1.1.0 - v4.0.1.1.1
	if Mounty.Ride.nomod then
		ride = Mounty.Ride.nomod.name;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Ride Mount|r");
		reset = true;
	end
	if Mounty.Fly.nomod then
		fly = Mounty.Fly.nomod.name;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Fly Mount|r");
		reset = true;
	end
	if Mounty.Ride.Shift then
		shiftride = Mounty.Ride.Shift.name;
	else
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Shift Ride Mount|r");
		shiftride = ride;
	end
	if Mounty.Fly.Shift then
		shiftfly = Mounty.Fly.Shift.name;
	else
		reset = true;
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Fly Mount|r");
		shiftfly = fly;
	end
	local buttonString;
	local old = {};
	local shiftold = {};
	for i=1,9 do
		old[i] = MOUNTYNOTSET;
		shiftold[i] = MOUNTYNOTSET;
	end
	if Mounty.MiddleButton then
		if Mounty.MiddleButton.nomod then
			middle = Mounty.MiddleButton.nomod.name;
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting MiddleButton Mount|r");
			reset = true;
		end
		if Mounty.MiddleButton.Shift then
			shiftmiddle = Mounty.MiddleButton.Shift.name;
		else
			reset = true;
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Shift MiddleButton Mount|r");
			shiftmiddle = middle;
		end
		for i=4,9 do
			buttonString = "Button"..i;
			if Mounty[buttonString].nomod then
				old[i] = Mounty[buttonString].nomod.name;
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting "..buttonString.." Mount|r");
				reset = true;
			end
			if Mounty[buttonString].Shift then
				shiftold[i] = Mounty[buttonString].Shift.name;
			else
				reset = true;
				DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 Resetting Shift MiddleButton Mount|r");
				shiftold[i] = old[i];
			end
		end
	else
		Mounty["MiddleButton"] = {}
		Mounty.MiddleButton["nomod"] = {};
		Mounty.MiddleButton.nomod["name"] = MOUNTYNOTSET;
		Mounty.MiddleButton.nomod["coord"] = 0;
		Mounty.MiddleButton["Shift"] = {};
		Mounty.MiddleButton.Shift["name"] = MOUNTYNOTSET;
		Mounty.MiddleButton.Shift["coord"] = 0;
		
		local i,ii;
		local buttonString;
		for i=4,9 do
			buttonString = "Button"..i;
			Mounty[buttonString] = {}
			Mounty[buttonString]["nomod"] = {};
			Mounty[buttonString].nomod["name"] = MOUNTYNOTSET;
			Mounty[buttonString].nomod["coord"] = 0;
			Mounty[buttonString]["Shift"] = {};
			Mounty[buttonString].Shift["name"] = MOUNTYNOTSET;
			Mounty[buttonString].Shift["coord"] = 0;
		end
		reset = true;

	end
	local mty = MOUNTY;
	MOUNTY = nil;
	MOUNTY = {
		["Alliance"] = {
			["ride"] = MOUNTYNOTSET;
			["shiftride"] = MOUNTYNOTSET;
			["fly"] = MOUNTYNOTSET;
			["shiftfly"] = MOUNTYNOTSET;
		};
		["Horde"] = {
			["ride"] = MOUNTYNOTSET;
			["shiftride"] = MOUNTYNOTSET;
			["fly"] = MOUNTYNOTSET;
			["shiftfly"] = MOUNTYNOTSET;
		};
		["Owned"] = {};
		["MAP"] = {};
		["AddMap"] = {};
	};

---- END BLOCKS
	if reset then
		Mounty_Reset();
---- Recover previous settings
		Mounty.perChar = pchar;
		Mounty.SafeFly = safe;
		Mounty.Enabled = enabled;
		Mounty.Fly.nomod.name = fly;
		Mounty.Ride.nomod.name = ride;
		Mounty.MiddleButton.nomod.name = middle;
		Mounty.Fly.Shift.name = shiftfly;
		Mounty.Ride.Shift.name = shiftride;
		Mounty.MiddleButton.Shift.name = shiftmiddle;
		for i=4,9 do
			buttonString = "Button"..i;
			Mounty[buttonString].nomod["name"] = old[i];
			Mounty[buttonString].Shift["name"] = shiftold[i];
		end
		Mounty_SetMountID();
	end
	MOUNTY = {
		["Alliance"] = {
			["ride"] = mty.Alliance.ride;
			["shiftride"] = mty.Alliance.shiftride;
			["fly"] = mty.Alliance.fly;
			["shiftfly"] = mty.Alliance.shiftfly;
		};
		["Horde"] = {
			["ride"] = mty.Horde.ride;
			["shiftride"] = mty.Horde.shiftride;
			["fly"] = mty.Horde.fly;
			["shiftfly"] = mty.Horde.shiftfly;
		};
		["Owned"] = Mounty_SetOwnedList();
		["MAP"] = mty.MAP;
		["AddMap"] = mty.AddMap;
	};
end

function Mounty_Reset()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Mounty has reset:");
	if not Mounty.Version then
		Mounty["Version"] = "0.0.0.0.0";
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Version.."|r");
	end
	Ability = Mounty_ResetAbility(Ability);
		
	Mounty = nil;
	Mounty ={};
	Mounty["Name"] = MOUNTY_NAME;
	Mounty["Version"] = MOUNTY_VERSION;
	Mounty["FileNumber"] = MOUNTY_FILENUM;
	Mounty["SelectEnable"] = true;
	Mounty["Enabled"] = false;
	Mounty["SafeFly"] = true;
	Mounty["perChar"] = false;
	Mounty["Fly"] = {}
	Mounty.Fly["nomod"] = {};
	Mounty.Fly.nomod["name"] = MOUNTYNOTSET;
	Mounty.Fly.nomod["coord"] = 0;
	Mounty["Ride"] = {}
	Mounty.Ride["nomod"] = {};
	Mounty.Ride.nomod["name"] = MOUNTYNOTSET;
	Mounty.Ride.nomod["coord"] = 0;
	Mounty.Ride["Shift"] = {};
	Mounty.Ride.Shift["name"] = MOUNTYNOTSET;
	Mounty.Ride.Shift["coord"] = 0;
	Mounty.Fly["Shift"] = {};
	Mounty.Fly.Shift["name"] = MOUNTYNOTSET;
	Mounty.Fly.Shift["coord"] = 0;
	Mounty["MiddleButton"] = {}
	Mounty.MiddleButton["nomod"] = {};
	Mounty.MiddleButton.nomod["name"] = MOUNTYNOTSET;
	Mounty.MiddleButton.nomod["coord"] = 0;
	Mounty.MiddleButton["Shift"] = {};
	Mounty.MiddleButton.Shift["name"] = MOUNTYNOTSET;
	Mounty.MiddleButton.Shift["coord"] = 0;
	
	Mounty_ClearMounts();
	
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..Mounty.Version.."|r");
	Mounty_InitializeVar();
end

function Mounty_ClearMounts()
	if Mounty_CombatCheck() and MOUNTY_ALIVE then 
		local i,ii;
		local buttonString;
		for i=4,9 do
			buttonString = "Button"..i;
			Mounty[buttonString] = nil;
			Mounty[buttonString] = {}
			Mounty[buttonString]["nomod"] = {};
			Mounty[buttonString].nomod["name"] = MOUNTYNOTSET;
			Mounty[buttonString].nomod["coord"] = 0;
			Mounty[buttonString]["Shift"] = {};
			Mounty[buttonString].Shift["name"] = MOUNTYNOTSET;
			Mounty[buttonString].Shift["coord"] = 0;
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- << MOUNTY USE >> -- Called by the macro      ********************************************************************************
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_Use()
	local button, buttonString = Mounty_GetMacroButton();
	local mountname = "Not Set";
	local mountid = 0;
--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Button Number - String|r = |cff00ffff"..button.." - "..buttonString.."|r");
	if FirstUse then
		Mounty_SetAll();
		FirstUse = false;
	end
	if(Macro.Writing == false) then
		Macro.Using = true;
		if not Mounty_Exit() then
			local fly = Mounty_SetFlyable();
			local flyid = Mounty.Fly[Button.Modifier].coord;
			local rideid = Mounty.Ride[Button.Modifier].coord;
			local flyname = Mounty.Fly[Button.Modifier].name;
			local ridename = Mounty.Ride[Button.Modifier].name;
-- Vashj'ir segment -------------------------------------------------
			if MOUNTY_SWIMFLAG and MOUNTY_VASHJ_FLAG then
				local modifier = Button.Modifier;
				fly = true; --- for the nonflyable returns that occur
				if Ability.Vashj then
					if modifier == "nomod" then
						flyid = Vashj.coord;
						flyname = Vashj.name;
					end				
					if modifier == "Shift" then
						flyid = Mounty.Fly.nomod.coord;
						flyname = Mounty.Fly.nomod.name;
						if not Ability.Fly then
							flyid = Vashj.coord;
							flyname = Vashj.name;
						end
					end
				else
					if modifier == "nomod" then
						flyid = Mounty.Ride[modifier].coord;
						flyname = Mounty.Ride[modifier].name;
					end				
					if modifier == "Shift" then
						flyid = Mounty.Fly.nomod.coord;
						flyname = Mounty.Fly.nomod.name;
						if not Ability.Fly then
							flyid = Mounty.Ride[modifier].coord;
							flyname = Mounty.Ride[modifier].name;
						end
					end
				end				
			end
---------------------------------------------------------------------
--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Button Number - String|r = |cff00ffff"..button.." - "..buttonString.."|r");
--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Button Number - String|r = |cff00ffff"..mountid.." - "..mountname.."|r");
			if(button == 2) then
				fly = false;
			end
			if fly then
				mountid = flyid;
				mountname = flyname;
			else
				mountid = rideid;
				mountname = ridename;
			end
			if(button > 2) and ( Mounty[buttonString][Button.Modifier].coord > 0)then
				mountname = Mounty[buttonString][Button.Modifier].name;
				mountid = Mounty[buttonString][Button.Modifier].coord;
			end
			if mountid > 0 then 
				Mounty_Mount(mountid);
--DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Button Number - String|r = |cff00ffff"..mountid.." - "..mountname.."|r");
			else 
				if Button.Modifier == "nomod" then 
					DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty Error> -- |r|cffffff00No Mount has been set for "..buttonString..".|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty Error> -- |r|cffffff00No Mount has been set for "..Button.Modifier.." "..buttonString..".|r");
				end
				Mounty_Sound("error");
			end
		end
		Macro.Using = false;
	end
end

function Mounty_Exit()
	local flag, flying = false, false;
	Mounty_SetStateVariables(State);
	if(State.IsMounted) then 
		local buttonNumber = Mounty_GetMacroButton();
		local dismount = false;
		if IsFlying() then
			flying = true;
			if Mounty.SafeFly then
				if(buttonNumber == 2) then
					dismount = true;
				end
			else
				dismount = true;
			end
		else
			dismount = true;
		end
		if dismount then
			if(Mounty_CheckMountAura()) then
				local aura = Mounty_CheckMountAura();
				if Mounty_CombatCheck() and MOUNTY_ALIVE then 
					CancelUnitBuff("player", aura);
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Mounty> -- Unable to dismout "..aura..".|r");
					DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Mounty> -- In Combat use:|r");
					DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Mounty> -- "..aura.." icon (Garrison Ability)|r");
				end
				flag = true;
			end
			if(CanExitVehicle()) then 
				VehicleExit();
				flag = true;
			end
			if not flag then 
				Mounty_Dismount();
				flag = true;
			end
		end
	end
	if flying then 
		if not flag then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Mounty> -- SafeFly has blocked dismount/exit.|r");
			flag = true;
		end
	end
	return flag;
end

function Mounty_GetMacroButton()
	local buttonNumber = 0;
	local buttonString = "None";
--	local macroIndex = GetRunningMacro();
	buttonString = GetRunningMacroButton();
	buttonNumber = Button[buttonString];
	if not buttonNumber then
		buttonNumber = 1;
		buttonString = "LeftButton";
	end
	Mounty_GetModifierKey();
	if Button.Alt then
		buttonNumber = 2;
		buttonString = "RightButton";
	end
	return buttonNumber, buttonString;
end

function Mounty_GetModifierKey()
	local rt = {};
	Button.Modifier = "nomod";
	Button.modNum = 0;
	Button.nomod = true;
	Button.Shift = false;
	Button.Ctrl = false;
	Button.Alt = false;

	if IsModifierKeyDown() then
		Button.nomod = false;
		if IsAltKeyDown() then
			Button.modNum = Button.modNum + 3;
			Button.Modifier = "Alt";
			Button[Button.Modifier] = true;
		end
		if IsControlKeyDown() then
			Button.modNum = Button.modNum + 20;
			Button.Modifier = "Ctrl";
			Button[Button.Modifier] = true;
		end
		if IsShiftKeyDown() then
			Button.modNum = Button.modNum + 100;
			Button.Modifier = "Shift";
			Button[Button.Modifier] = true;
		end
		if Button.Modifier == "Ctrl" or Button.Modifier == "Alt" then
			Button.Modifier = "nomod";
		end
	end
--	Button.modNum:
--	100	= shift
--	20	= ctrl
--	3	= alt
--	120	= shift+ctrl
--	103	= shift+alt
end

--------------------------------------------------------------------------------------------------------------------------------
-- Initial Support and Slash Command
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetEnable()
	Mounty.Enabled = false;
	if Mounty.SelectEnable then
		if Ability.Ride and (Ability.Mount.name.ride ~= MOUNTYNOTSET) then
			Mounty.Enabled = true;
		else
			Mounty_PrintUnable();
		end
		if Mounty.Enabled then
			local test = Mounty_FindMacro();
			if test < 0 then
			 	Mounty_Sound("error");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
			end
		end
	end
	return Mounty.Enabled;
end

function Mounty_Enable()
	if Mounty.SelectEnable then
	  	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already SELECTED to Enabled.|r");
	end
	if Mounty.Enabled then
	 	Mounty_Sound("error");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Mounty> Mounty was already enabled.|r");
  		Mounty_Disable();
	end
	Mounty.SelectEnable = true;
	if Mounty_CombatCheck() and MOUNTY_ALIVE then
		Mounty.Enabled = false;
		if(Mounty_GetMacroSpace()) then
			Mounty.Enabled = true;
			Mounty_SetAll();
--			Mounty_PrintSettings(true);
			if Mounty.Enabled then
				Mounty_WriteMacro();
			 	Mounty_Sound("action");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> is Enabled.|r");
		  	end
	 	else  
		 	Mounty_Sound("error");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		end
 	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end		
end

function Mounty_Disable()
	if Mounty_CombatCheck() and MOUNTY_ALIVE then
		if not Mounty.SelectEnable then
		  	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already SELECTED to Disabled.|r");
		else
			Mounty.SelectEnable = false;
		end
		if Mounty.Enabled then
			Mounty_DeleteMacro();
			Mounty.Enabled = false;
-- 			Mounty_PrintSettings(true);
		 	Mounty_Sound("action");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is Disabled.|r");
		else
		 	Mounty_Sound("error");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already selcted to Disabled.|r");
		end
	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end  
end

function Mounty_perCharToggle()
	Mounty_DeleteMacro();
	local entry = Mounty.perChar;
	Mounty_GetMacroSpace();
	if(Mounty.perChar) then
		if(Macro.GENSPACE) then
			Mounty.perChar = false;
		end
	else
		if(Macro.CHARSPACE) then
			Mounty.perChar = true;
		end
	end
	if(entry == Mounty.perChar) then
	 	Mounty_Sound("error");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000UNABLE to move MACRO!! -- No Space|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------|r");
	elseif (Mounty.perChar) then
	 	Mounty_Sound("action");
 		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 Character Specific Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  	else
	 	Mounty_Sound("action");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 General Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------|r");
   	end
	Mounty_WriteMacro();		
end

function Mounty_SafeFlyToggle()
		if Mounty.SafeFly then
			Mounty.SafeFly = false;
			Macro.safeflytxt = " ";
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r");
		else
			Mounty.SafeFly = true;
			Macro.safeflytxt = MOUNTY_SAFEFLY;
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r");
		end
end

function Mounty_SetFlyable()
	local fly = false;
	if Ability.Fly and (Ability.Mount.name.fly  ~= MOUNTYNOTSET) then
		Flyable = Ability.Location[MOUNTY_CCont];
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r Continent =|cffff0000 "..Continent.."|r");
		if Flyable then
			Flyable = Mounty_WintergraspCheck();
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r Flyable =|cffff0000 TRUE|r");
		else
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r Flyable =|cffff0000 FALSE|r");
		end
	end
	Macro.flyable = Flyable;
	if IsFlyableArea() or Wintergrasp.Flag then
		fly = Flyable;
	end
	Flyable = fly;
	return fly;
end

function Mounty_Wintergrasp()
	local timer = false;
	if (Mounty_GetWintergraspWaitTime()>0) then
		timer = true;
	end
	timer = true;
	Wintergrasp.Flag = false;
	Wintergrasp.Timer = true;
	if ("Wintergrasp" == GetRealZoneText()) then
		Wintergrasp.Flag = true;
		Wintergrasp.Timer = timer;
	end
	return timer;
end

function Mounty_GetWintergraspWaitTime()
	local WintergraspTimer = 0;
	local pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(1)
	local ii = GetNumWorldPVPAreas();
	for i=1,ii do
		pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(i)
		if localizedName == "Wintergrasp" then
			if isActive then
				WintergraspTimer = 0;
			else
				WintergraspTimer = startTime;
			end
		end
	end
	return WintergraspTimer;
end

function Mounty_WintergraspCheck()
	Mounty_Wintergrasp();
	local timer = Wintergrasp.Timer;
	return timer;
end

function Mounty_CombatCheck()
	local combatcheck = true;
	if InCombatLockdown() then
		combatcheck = nil;
	end
	return combatcheck;
end

function Mounty_ExitCombat()
	if (Macro.combatflag == true) then
		Macro.combatflag = false;
		Mounty_WriteMacro();		
	end
end

function Mounty_Alive()
	MOUNTY_ALIVE = true;
	Mounty_WriteMacro();		
end

--------------------------------------------------------------------------------------------------------------------------------
-- Macro
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_WriteMacro()
	if Mounty_CombatCheck() and MOUNTY_ALIVE then
		if not Macro.Using then
			Macro.Writing = true;
			local macroID;
			local macroIndex = Mounty_FindMacro();
			if macroIndex == 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = CreateMacro(Macro.NAME, iconNum, body, perChar, serv);
				Macro.Index = Mounty_FindMacro();
			elseif macroIndex > 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = EditMacro(macroIndex, Macro.NAME, iconNum, body, serv, eperChar);
				Macro.Index = macroIndex;
			elseif macroIndex < 0 then
			 	Mounty_Sound("error");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------|r");
		  		Macro.Index = 0;
		   		Mounty_Disable();
			end
			Macro.Writing = false;
		end
	else
		Macro.combatflag = true;
	end
end

function Mounty_SetMacroBody()
	Mounty_SetMountID();
	MOUNTY_CNum, MOUNTY_CONTINENT, MOUNTY_ZNum, MOUNTY_ZONE = Mounty_GetMapZone();
	Mounty_SetFlyable();
	local textline = {
		[1] ="";
		[2] ="";
	};
	local flyable = ",flyable\]";
	if Wintergrasp.Flag then
		flyable = "\]";
	end
	local flynomod = Mounty_MacroChauffeured(Mounty.Fly.nomod.name);
	local flyshift = Mounty_MacroChauffeured(Mounty.Fly.Shift.name);
	local ridenomod = Mounty_MacroChauffeured(Mounty.Ride.nomod.name);
	local rideshift = Mounty_MacroChauffeured(Mounty.Ride.Shift.name);
	
-- Vashj'ir segment -------------------------------------------------
	if MOUNTY_SWIMFLAG and MOUNTY_VASHJ_FLAG then
		if Ability.Vashj then
			Macro.flyable = true;
			flyable = "\]";
			flynomod = Vashj.name;
			flyshift = Mounty.Fly.nomod.name;
			if not Ability.Fly then
				flyshift = Vashj.name;
			end
		else
			Macro.flyable = true;
			flyable = "\]";
			flynomod = Mounty.Ride.nomod.name;
			flyshift = Mounty.Fly.nomod.name;
			if not Ability.Fly then
				flyshift = Mounty.Ride.nomod.name;
			end
		end
	end
----------------------------------------------------------------------
--	Line 1
	if(Macro.flyable) then
		textline[1] = "#showtooltip \[nomod:alt,mod:shift"..flyable..flyshift..";\[nomod:alt"..flyable..flynomod..";\[mod:shift\]"..rideshift..";"..ridenomod.."\n";
--		textline[1] = "#showtooltip \[mod:alt,mod:shift\]"..rideshift..";\[nomod:alt,mod:shift"..flyable..flyshift..";\[nomod:alt"..flyable..flynomod..";\[mod:alt\]"..ridenomod..";"..ridenomod.."\n";
	else
		textline[1] = "#showtooltip \[mod:shift\]"..rideshift..";"..ridenomod.."\n";
	end
	if(Ability.Skill.Special) then
		textline[1] = "#showtooltip "..ridenomod.."\n";
	end
	
	
--	Line 2
	textline[2] = "/run Mounty_Use()\n";

	body = textline[1]..textline[2];
	return body;
end

function Mounty_MacroChauffeured(name)
	local hordeC = "Chauffeured Mechano-Hog";
	local allianceC = "Chauffeured Mekgineer's Chopper";
	if (name == allianceC) or (name == hordeC) then
		name = "Summon Chauffeur";
	end
	return name;
end

function Mounty_SetMacroValues()
	local iconTexture = Macro.iconTexture;
	local iconNum = "INV_Misc_QuestionMark" -- iconNum = Macro.iconNum;
	local perChar = nil;
	local eperChar = 0;
	local serv = Macro.SAVE;
	if(Mounty.perChar) then
		perChar = 1;
		eperChar = 1;
	end
	Macro.perChar = Mounty.perChar;
	return iconNum, serv, perChar, eperChar;
end

function Mounty_FindMacro()
	local space = Mounty_GetMacroSpace();
	local index = GetMacroIndexByName(Macro.NAME);
	local returnindex = index;
	if(index == 0) then
		if(Mounty.perChar) then
			if not Macro.CHARSPACE then
				returnindex = returnindex - 1;
			end
		else
			if not Macro.GENSPACE then
				returnindex = returnindex - 1;
			end
		end
	end
	return returnindex;
end

function Mounty_GetMacroSpace()
	Macro.GENSPACE = false;
	Macro.CHARSPACE = false;
	local space = false;
	local numgen,numperchar = GetNumMacros();
	if(numgen < Macro.MAXGEN) then
		Macro.GENSPACE = true;
		space = true;
	end
	if(numperchar < Macro.MAXCHAR) then
		Macro.CHARSPACE = true;
		space = true;
	end
	return space;
end

function Mounty_DeleteMacro()
	local index = Mounty_FindMacro();
--	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Macro Index = "..index..".|r");
	if(index > 0) then
		DeleteMacro(index);
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Mounts
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetMountID()
	Mounty_GetRidingSkill();
	if Ability.Ride then
		Vashj.name = "Unknown"
		Vashj.coord = 0;
		Ability.Vashj = false;
		Ability.Mount.mounts = MOUNTY.Owned[Mounty.Faction][0];
		local xx, i, n = Ability.Mount.mounts, 0, "Not Set";
		if(xx > 0) then
			for x = 1,xx do
				i = MOUNTY.Owned[Mounty.Faction][x].ID;
				n = MOUNTY.Owned[Mounty.Faction][x].name;
				if not (MOUNTY.Owned[Mounty.Faction][x].mountType == 232) then
					if n == Mounty.Ride.nomod.name then
						Mounty.Ride.nomod.coord = i;
						Ability.Mount.name.ride = n;
					end
					if n == Mounty.Ride.Shift.name then
						Mounty.Ride.Shift.coord = i;
						Ability.Mount.name.shiftride = n;
					end
					if n == Mounty.Fly.nomod.name then
						Mounty.Fly.nomod.coord = i;
						Ability.Mount.name.fly = n;
					end
					if n == Mounty.Fly.Shift.name then
						Mounty.Fly.Shift.coord = i;
						Ability.Mount.name.shiftfly = n;
					end
					if n == Mounty.MiddleButton.nomod.name then
						Mounty.MiddleButton.nomod.coord = i;
					elseif n == Mounty.MiddleButton.Shift.name then
						Mounty.MiddleButton.Shift.coord = i;
					end
					local b, buttonString = 0, "Button";
					for b=4,9 do
						buttonString = "Button"..b;
						if n == Mounty[buttonString].nomod.name then
							Mounty[buttonString].nomod.coord = i;
						elseif n == Mounty[buttonString].Shift.name then
							Mounty[buttonString].Shift.coord = i;
						end
					end
				end
			end
		end
	end
end

function Mounty_ConvertSetVal(flyorride)
	local returnvalue = 0;
	if (flyorride == "fly") then returnvalue = 1; end
	if (flyorride == "left") then returnvalue = 1; end
	if (flyorride == "ride") then returnvalue = 2; end
	if (flyorride == "right") then returnvalue = 2; end
	if (flyorride == "middle") then returnvalue = 3; end
	return returnvalue;
end

function Mounty_SetMount(buttonIndex)
	Mounty_GetModifierKey();
	Mounty_SetMountID();
	local name, level, coord = "Not Mounted", 0, 0;
	local active = Mounty_GetActiveMount();
	if active == 0 then
--	 	Mounty_Sound("error");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." must be mounted to Set a mount.|r");
   	else
   		local mount = Mounty_GetMountJournalInfo(active);
   		name = mount.name;
   		coord = mount.ID;
   		if mount.mountType == 232 then
		 	Mounty_Sound("error");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000The Vashj'ir mount may not be set.|r");
	   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000The Vashj'ir mount is handled automatically.|r");
   		else
			if buttonIndex < 1 or not buttonIndex then
			 	Mounty_Sound("error");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine mount setting.|r");
		   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty fly -or- /mty ride -or- /mty # (1-9)|r");
		   	else
		   		if buttonIndex == 1 then
		   			Mounty.Fly[Button.Modifier].name = name;
		   			Mounty.Fly[Button.Modifier].coord = active;
					Mounty_PrintSettings(true);
		   		elseif buttonIndex == 2 then
		   			Mounty.Ride[Button.Modifier].name = name;
		   			Mounty.Ride[Button.Modifier].coord = active;
		 			Mounty_PrintSettings(true);
		   		elseif buttonIndex == 3 then
		   			Mounty.MiddleButton[Button.Modifier].name = name;
		   			Mounty.MiddleButton[Button.Modifier].coord = active;
					Mounty_PrintSettings(true);
				elseif (buttonIndex > 3) and (buttonIndex < 10) then
					local buttonString = "Button"..buttonIndex;
		   			Mounty[buttonString][Button.Modifier].name = name;
		   			Mounty[buttonString][Button.Modifier].coord = active;
					Mounty_PrintSettings(true);
		   		else
				 	Mounty_Sound("error");
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine if setting flying mount or riding mount.|r");
			   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty fly -or- /mty ride|r");
		   		end
	   		end
   		end
		Mounty_WriteMacro();		
	end
	local faction = Mounty.Faction;
	local mty = MOUNTY[faction];
	mty.ride = Mounty.Ride.nomod.name;
	mty.shiftride = Mounty.Ride.Shift.name;
	mty.fly = Mounty.Fly.nomod.name;
	mty.shiftfly = Mounty.Fly.Shift.name;
	MOUNTY[faction] = mty;
	Ability.Mount.name = MOUNTY[faction];
end

function Mounty_CheckDefaultMount()
	if DEFMOUNT then
		DEFMOUNT = false;
		Mounty_SetDefMountList();
		if Mounty.Ride.nomod.name == MOUNTYNOTSET then
			Mounty.Ride.nomod.name = Ability.Mount.name.ride;
		end
		if Mounty.Ride.Shift.name == MOUNTYNOTSET and Ability.Mount.name.shiftride ~= MOUNTYNOTSET then
			Mounty.Ride.Shift.name = Ability.Mount.name.shiftride;
		end
		if Mounty.Fly.nomod.name == MOUNTYNOTSET then
			Mounty.Fly.nomod.name = Ability.Mount.name.fly;
		end
		if Mounty.Fly.Shift.name == MOUNTYNOTSET then
			Mounty.Fly.Shift.name = Ability.Mount.name.shiftfly;
		end
		Ability.Mount.name.ride = Mounty.Ride.nomod.name;
		Ability.Mount.name.shiftride = Mounty.Ride.Shift.name;
		Ability.Mount.name.fly = Mounty.Fly.nomod.name;
		Ability.Mount.name.shiftfly = Mounty.Fly.Shift.name;
		MOUNTY[Mounty.Faction] = Ability.Mount.name;
		Mounty_SetDefMountList();
	end
end

function Mounty_SetDefMountList()
	local faction = Mounty.Faction;
	local mty = MOUNTY[faction];
	if mty.ride == MOUNTYNOTSET then
		mty.ride = Mounty_GetTypeMount(faction, 230);
	end
	if mty.ride == MOUNTYNOTSET then
		mty.ride = Mounty_GetTypeMount(faction, 248);
	end
	if mty.shiftride == MOUNTYNOTSET then
		mty.shiftride = mty.ride;
	end
	if mty.fly == MOUNTYNOTSET then
		mty.fly = Mounty_GetTypeMount(faction, 248);
	end
	if mty.shiftfly == MOUNTYNOTSET then
		mty.shiftfly = mty.fly;
	end
	MOUNTY[faction] = mty;
	Ability.Mount.name = mty;
end

function Mounty_SpecialMount()
	if Mounty_CombatCheck() and MOUNTY_ALIVE then 
		Ability.Skill.Special = true;
		Mounty_GetRidingSkill();
		if Ability.Skill.Special then
			local name, id = Mounty_GetSpecialMount(Mounty.Faction, 284);
			
			Ability.Mount.name.ride = name;
			Ability.Mount.name.shiftride = name;
			Ability.Mount.name.fly = name;
			Ability.Mount.name.shiftfly = name;
	
			Mounty.Ride.nomod.name = name;
			Mounty.Ride.nomod.coord = id;
			Mounty.Fly.nomod.name = name;
			Mounty.Fly.nomod.coord = id;
			Mounty.MiddleButton.nomod.name = name;
			Mounty.MiddleButton.nomod.coord = id;
			
			Mounty.Ride.Shift.name = name;
			Mounty.Ride.Shift.coord = id;
			Mounty.Fly.Shift.name = name;
			Mounty.Fly.Shift.coord = id;
			Mounty.MiddleButton.Shift.name = name;
			Mounty.MiddleButton.Shift.coord = id;
			
			Mounty_ClearMounts();
		end
	end
end

function Mounty_SetVashMount(i, name)
	Ability.Vashj = true;
	Vashj.name = name;
	Vashj.coord = i;
end

function Mounty_ClearVashMount()
	Ability.Vashj = false;
	Vashj.name = MOUNTYNOTSET;
	Vashj.coord = 0;
end

--------------------------------------------------------------------------------------------------------------------------------
-- Riding Skills
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_GetRidingSkill()
	local change = false;
	Mounty_ClearRidingSkill();
	local s, i, ii = 1, 1, MAX_SKILLLINE_TABS;
	local spell, spell1, spell2, spell3, spellsub = "", "", "", "", "";
	local isusable = nil;
	for i = 1, ii do
		local name, texture, offset, numSpells = GetSpellTabInfo(i, BOOKTYPE_SPELL);
		if name == "General" then
			for s = offset + 1, offset + numSpells do
				spell, spellsub = GetSpellBookItemName(s, BOOKTYPE_SPELL);
				isusable = IsUsableSpell(spell);
				if isusable then
					_,_,spell1, spell2 = string.find(spell, "(%S+) (%S+)");
					if spell == "Wisdom of the Four Winds" then
						change = Mounty_SetRidingSkill("Wisdom of the Four Winds");
					elseif spell == "Silver Dollar Club" then
						change = Mounty_SetRidingSkill("Silver Dollar Club");
					elseif spell == "Dragoon" then
						change = Mounty_SetRidingSkill("Dragoon");
					elseif spell == "Master Scout" then
						change = Mounty_SetRidingSkill("Master Scout");
					elseif spell == "Mount Up" then
						change = Mounty_SetRidingSkill("Mount Up");
					elseif spell == "Cold Weather Flying" then
						change = Mounty_SetRidingSkill("Cold Weather Flying");
					elseif spell == "Flight Master's License" then
						change = Mounty_SetRidingSkill("Flight Master's License");
					elseif spell2 == "Riding" then
						change = Mounty_SetRidingSkill(spell1);
					end
				end
			end
		end
	end
	return change;
end

function Mounty_ClearRidingSkill()
	Ability.Ride = Ability.Skill.Special;
	Ability.Fly = false;
	
	Ability.Location["Draenor"] = false;
	Ability.Location["Pandaria"] = false;
	Ability.Location["Northrend"] = false;
	Ability.Location["Outland"] = false;
	Ability.Location["Kalimdor"] = false;
	Ability.Location["Eastern"] = false;
	Ability.Location["Maelstrom"] = false;
	
	Ability.Skill["Apprentice"] = false;
	Ability.Skill["Journeyman"] = false;
	Ability.Skill["Expert"] = false;
	Ability.Skill["Artisan"] = false;
	Ability.Skill["Master"] = false;
	Ability.Skill["License"] = false;
	Ability.Skill["Cold"] = false;
	Ability.Skill["WFW"] = false;
	Ability.Skill["MountUp"] = false;
	Ability.Skill["Stables"] = false;
end

function Mounty_SetRidingSkill(name)
	local change = false;
	if name == "Wisdom of the Four Winds" then
		if not Ability.Skill["WFW"] then change = true; end
		Ability.Skill["WFW"] = true;
		Ability.Location["Pandaria"] = true;
	elseif name == "Mount Up" then
		Ability.Skill["MountUp"] = true;
	elseif name == "Silver Dollar Club" then
		Ability.printout.Stables = 1;
	elseif name == "Dragoon" then
		Ability.printout.Stables = 2;
	elseif name == "Master Scout" then
		Ability.printout.Stables = 3;
		Ability.Skill.Stables = true;
	elseif name == "Cold Weather Flying" then
		if not Ability.Skill["Cold"] then change = true; end
		Ability.Skill["Cold"] = true;
		Ability.Location["Northrend"] = true;
	elseif name == "Flight Master's License" then
		if not Ability.Skill["License"] then change = true; end
		Ability.Skill["License"] = true;
		Ability.Location["Kalimdor"] = true;
		Ability.Location["Eastern"] = true;
		Ability.Location["Maelstrom"] = true;
	elseif (name == "Expert") or (name == "Artisan") or (name == "Master") then
		Ability.Skill.Special = false;
		Ability.Ride = true;
		Ability.Fly = true;
		if not Ability.Skill[name] then change = true; end
		Ability.Skill[name] = true;
		Ability.Location["Outland"] = true;
	elseif (name == "Apprentice") or (name == "Journeyman") then
		Ability.Skill.Special = false;
		if not Ability.Skill[name] then change = true; end
		Ability.Skill[name] = true;
		Ability.Ride = true;
	end
	if(Ability.Ride) then
--[[
		local a = false;
		for r,v in pairs(Ability.Skill) do
			Ability.printout[r] = a;
			if (v) then
				a = true;
			end 
			print(r,Ability.printout[r], "NO COMMENT")
		end
--]]
		if Ability.Skill.Apprentice then
			Ability.printout.Apprentice = false;
		end
		if Ability.Skill.Journeyman then
			Ability.printout.Apprentice = false;
			Ability.printout.Journeyman = false;
		end
		if Ability.Skill.Expert then
			Ability.printout.Apprentice = false;
			Ability.printout.Journeyman = false;
			Ability.printout.Expert = false;
		end
		if Ability.Skill.Artisan then
			Ability.printout.Apprentice = false;
			Ability.printout.Journeyman = false;
			Ability.printout.Expert = false;
			Ability.printout.Artisan = false;
		end
		if Ability.Skill.Master then
			Ability.printout.Apprentice = false;
			Ability.printout.Journeyman = false;
			Ability.printout.Expert = false;
			Ability.printout.Artisan = false;
			Ability.printout.Master = false;
		end
--[[
		for r,v in pairs(Ability.printout) do
			print(r,v)
		end
--]]
	end
	return change;
end

--------------------------------------------------------------------------------------------------------------------------------
-- Print Functions
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_Message(top)
	Mounty_WriteMacro();		
	if Mounty.SelectEnable then
		Mounty_PrintMenu(top);
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 Disabled|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r| Type /mty enable (to enable Mounty)");
	end
end

function Mounty_PrintInfo()
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..Mounty.FileNumber.."|cff00ffff by Drae|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  Player: "..Mounty.PlayerColor.." = "..Mounty.Realm.." <> "..Mounty.Faction.." <> "..Mounty.PlayerClassColor);
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cff00ff00 Enabled|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000****************************************************|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffff6600As of 10/13/2014 Patch 6.0.2:|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffff6600Speed buffs are no longer multiplicative or stacked.|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffff6600REF: http://us.battle.net/wow/en/blog/15682579#movement_speed|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffff0000****************************************************|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00ABILITIES:");
	local spr,spf,ra,fa = 0,0,0,0;
	if Ability.Ride then
--			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff Current Riding Skill:|r");
		if Ability.Skill.Apprentice then
			spr,spf = 160,0;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffApprentice Riding|r (Riding "..spr.."% |cff00ffff- NO Flying|r)");
			DEFAULT_CHAT_FRAME:AddMessage("Journeyman Riding ( Riding "..Speed.Journeyman.ride.."% ) available at level "..Speed.Journeyman.available);
			DEFAULT_CHAT_FRAME:AddMessage("Expert Riding ( Flying "..Speed.Expert.fly.."% ) available at level "..Speed.Expert.available);
			DEFAULT_CHAT_FRAME:AddMessage("Artisan Riding ( Flying "..Speed.Artisan.fly.."% ) available at level "..Speed.Artisan.available);
			DEFAULT_CHAT_FRAME:AddMessage("Master Riding ( Flying "..Speed.Master.fly.."% ) available at level "..Speed.Master.available);
		elseif Ability.Skill.Journeyman then
			spr,spf = 200,0;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffJourneyman Riding|r (Riding "..spr.."% |cff00ffff- NO Flying|r)");
			DEFAULT_CHAT_FRAME:AddMessage("Expert Riding ( Flying "..Speed.Expert.fly.."% ) available at level "..Speed.Expert.available);
			DEFAULT_CHAT_FRAME:AddMessage("Artisan Riding ( Flying "..Speed.Artisan.fly.."% ) available at level "..Speed.Artisan.available);
			DEFAULT_CHAT_FRAME:AddMessage("Master Riding ( Flying "..Speed.Master.fly.."% ) available at level "..Speed.Master.available);
		elseif Ability.Skill.Expert then
			spr,spf = 200, 250;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffExpert Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
			DEFAULT_CHAT_FRAME:AddMessage("Artisan Riding ( Flying "..Speed.Artisan.fly.."% ) available at level "..Speed.Artisan.available);
			DEFAULT_CHAT_FRAME:AddMessage("Master Riding ( Flying "..Speed.Master.fly.."% ) available at level "..Speed.Master.available);
		elseif Ability.Skill.Artisan then
			spr,spf = 200, 380;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffArtisan Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
			DEFAULT_CHAT_FRAME:AddMessage("Master Riding ( Flying "..Speed.Master.fly.."% ) available at level "..Speed.Master.available);
		elseif Ability.Skill.Master then
			spr,spf = 200, 410;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffMaster Riding|r (Riding "..spr.."% - Flying "..spf.."%).");
		else
			Mounty_PrintUnable();
			Ability.Ride = false;
		end
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Speed Enhancements DO NOT STACK|r");
		if Ability.Skill.MountUp then
			if(ra<10) then 
				ra = 10;
			end
			if(fa<10) then 
				fa = 10;
			end
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffDoes have guild perk Mount Up.|r (Speed + 10%)");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Does NOT have guild perk Mount Up (Speed + 10%)|r");
		end
		if Ability.Skill.Stables then
			if(ra<20) then 
				ra = 20;
			end
			if(fa<20) then 
				fa = 20;
			end
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffDoes have Stables at Level 3.|r (Speed + 20%)");
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Does NOT have Stables at Level 3. (Speed + 20%)|r");
		end
		spr = spr + ra;
		spf = spf + fa;
		DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.." Rides at "..spr.."%");
		if spf == 0 then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|r|cffff0000 is UNABLE to Fly|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.." Flies at "..spf.."%");
		end
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
		if Ability.Skill.License then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cff00ffff has a Flight Master's License.|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cffff0000 does NOT have a Flight Master's License.|r");
		end
		if Ability.Skill.Cold then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cff00ffff has Cold Weather Flying.|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cffff0000 does NOT have Cold Weather Flying.|r");
		end
		if Ability.Skill.WFW then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cff00ffff has Wisdom of the Four Winds.|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cffff0000 does NOT have Wisdom of the Four Winds.|r");
		end
		local color = {};
		color[0] = "|cffff0000";
		color[1] = "|cffff9900";
		color[2] = "|cffffff00";
		color[3] = "|cff00ff00";
		if(Ability.printout.Stables == 0) then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor..color[Ability.printout.Stables].." has NO Stables.|r");
		else
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cffffff00 has Stables at ".."Level "..color[Ability.printout.Stables]..Ability.printout.Stables.."|r");
		end
		DEFAULT_CHAT_FRAME:AddMessage("Stables cumulative benefits: |r");
		DEFAULT_CHAT_FRAME:AddMessage(color[1].."  Level 1 = Operate while mounted.|r|cffffffff (Silver Dollar Club)");
		DEFAULT_CHAT_FRAME:AddMessage(color[2].."  Level 2 = May not be stunned while mounted.|r|cffffffff (Dragoon)");
		DEFAULT_CHAT_FRAME:AddMessage(color[3].."  Level 3 = 20% additional speed while mounted.|r|cffffffff (Master Scout)");
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
		DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.." may ride ground mounts on all continents.");
		if (Ability.Mount.name.ride == MOUNTYNOTSET) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r "..Mounty.Player.."|cffff0000 needs a mount to ride.");
		end
		if Ability.Fly and (Ability.Mount.name.fly  ~= MOUNTYNOTSET) then
			DEFAULT_CHAT_FRAME:AddMessage(Mounty.PlayerColor.."|cffffff00 may fly in:|r");
			if Ability.Location.Kalimdor then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cffff0000 No|r");
			end
			if Ability.Location.Eastern then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cffff0000 No|r");
			end
			if Ability.Location.Outland then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cffff0000 No|r");
			end
			if Ability.Location.Northrend then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cffff0000 No|r");
			end
			if Ability.Location.Maelstrom then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cffff0000 No|r");
			end
			if Ability.Location.Pandaria then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Pandaria =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Pandaria =|r|cffff0000 No|r");
			end
			if Ability.Location.Draenor then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Draenor =|r|cff00ff00 Yes|r");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Draenor =|r|cffff0000 No|r");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." is NOT able to fly.|r");
		end
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	else
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
		Mounty_PrintUnable();
	end
end

function Mounty_PrintUnable()
	if not Ability.Ride then
		DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." is unable to Ride or Fly.");
		DEFAULT_CHAT_FRAME:AddMessage("Apprentice Riding ( Riding "..Speed.Apprentice.ride.."% ) available at level "..Speed.Apprentice.available);
		DEFAULT_CHAT_FRAME:AddMessage("Journeyman Riding ( Riding "..Speed.Journeyman.ride.."% ) available at level "..Speed.Journeyman.available);
		DEFAULT_CHAT_FRAME:AddMessage("Expert Riding ( Flying "..Speed.Expert.fly.."% ) available at level "..Speed.Expert.available);
		DEFAULT_CHAT_FRAME:AddMessage("Artisan Riding ( Flying "..Speed.Artisan.fly.."% ) available at level "..Speed.Artisan.available);
		DEFAULT_CHAT_FRAME:AddMessage("Master Riding ( Flying "..Speed.Master.fly.."% ) available at level "..Speed.Master.available);
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must have at least Apprentice Riding.|r");
		if (Ability.Mount.name.ride == MOUNTYNOTSET) then
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must have at least ONE Mount to ride.|r");
		end
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	elseif (Ability.Mount.name.ride == MOUNTYNOTSET) then
		DEFAULT_CHAT_FRAME:AddMessage(PrintHead);
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must have at least ONE Mount to ride.|r");
		DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	end
end

function Mounty_PrintSettings(ding)
	if ding then
	 	Mounty_Sound("action");
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..Mounty.FileNumber.."|cff00ffff by Drae|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  Player: "..Mounty.PlayerColor.." = "..Mounty.Realm.." <> "..Mounty.Faction.." <> "..Mounty.PlayerClassColor);
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 SETTINGS:");
	if Mounty.SafeFly then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("(Right-Click or |cffffff00\[Alt\]|r-Click macro to dismount while flying.)");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("(Click macro to dismount while flying.)");
	end
	if Mounty.perChar then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 Character Specific Tab.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 General Tab.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	local buttonString = "Button";
	for i=4,9 do
		buttonString = "Button"..i;
		if Mounty[buttonString].nomod.coord > 0 then
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<"..buttonString.." Mount> |r|cff00ff00"..Mounty[buttonString].nomod.name.."|r");
		end
		if Mounty[buttonString].Shift.coord > 0 then
		   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift "..buttonString.." Mount> |r|cff00ff00"..Mounty[buttonString].Shift.name.."|r");
		end
	end
	if Mounty.Ride.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cff00ff00"..Mounty.Ride.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Riding Mount> |r|cff00ff00"..Mounty.Ride.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cffff0000"..Mounty.Player.." is unable to ride.|r");
	end
	if Mounty.Fly.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cff00ff00"..Mounty.Fly.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Flying Mount> |r|cff00ff00"..Mounty.Fly.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cffff0000"..Mounty.Player.." is unable to fly.|r");
	end
	if Mounty.MiddleButton.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<MiddleButton Mount> |r|cff00ff00"..Mounty.MiddleButton.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift MiddleButton Mount> |r|cff00ff00"..Mounty.MiddleButton.Shift.name.."|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

function Mounty_PrintMenu(top)
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: "..Mounty.FileNumber.."|cff00ffff by Drae|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  Player: "..Mounty.PlayerColor.." = "..Mounty.Realm.." <> "..Mounty.Faction.." <> "..Mounty.PlayerClassColor);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Menu options:|r (use /mty or /mounty)");
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	if top then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 TOP MENU:");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 FULL MENU:");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r Rewrites the <Mounty Macro> and shows TOP menu.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 reset|r = Resets the Mounty Addon.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 info|r = Shows ability and speed information.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 set|r = Shows current settings.");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 menu|r = Shows full menu of slash commands.");
	if not(top) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 show|r = Current Option and Mount selection.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 enable|r = Enable the Mounty Addon.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 disable|r = Disable the Mounty Addon.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 safe|r = Toggles Safefly on/off (default on)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 gen|r = <Mounty Macro> General Tab (Default).");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 char|r = <Mounty Macro> Character Specific Tab.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 clear|r = Clears mount selections 4 through 9.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 fly|r = Set currently |cffffff00ACTIVE|r mount to |cff00ffff<Flying Mount>|r.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 ride|r = Set currently |cffffff00ACTIVE|r mount to |cff00ffff<Riding Mount>|r.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 middle|r = Set currently |cffffff00ACTIVE|r mount to |cff00ffffMouse [MiddleButton] macro click|r.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 #|r (4 through 9) = Set currently |cffffff00ACTIVE|r mount to |cff00ffffMouse [Button#] macro click|r.");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Set the |r|cff00ff00<Shift Mounts>|r|cffffff00, by holding down the |cff00ffff\[Shift\]|r|cffffff00 key when pressing |r|cff00ffff\[Enter\]|r|cffffff00 on the slash commands above.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
end

function Mounty_BadMessage(message, badmessage)
	Mounty_Sound("error");
	Mounty_PrintMenu();
	DEFAULT_CHAT_FRAME:AddMessage(PrintLine);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <Mounty> --|r|cffff0000 Unable to understand command: |cffffff00"..message.."|r");
	if message == "set" then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffType -|r|cffffff00 /mty fly|r|cff00ffff   -to set a flying mount.|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffType -|r|cffffff00 /mty ride|r|cff00ffff -to set a riding mount.|r");
	end
end

function Mounty_Sound(sound)
	if sound == "error" then PlaySoundFile("Sound\\interface\\iQuestUpdate.wav"); end
	if sound == "action" then PlaySoundFile("Sound\\Universal\\FM_Land.wav"); end
end

--------------------------------------------------------------------------------------------------------------------------------
-- TEST Functions
--------------------------------------------------------------------------------------------------------------------------------
--[[ ---------------------- Block Remark START
function Mounty_Test()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <Mounty> --|r");
	for key, value in pairs(Ability.Mount.name) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..key.."|r = |cff00ffff"..value.."|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <MOUNTY> --|r");
	for key, value in pairs(MOUNTY[Mounty.Faction]) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..key.."|r = |cff00ffff"..value.."|r");
	end
	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	local continent = "Unkown";
--	if(contNum > 0) then
		continent = select(contNum, GetMapContinents());
continent = Mounty_603Continent(continent);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Name = "..continent.."|r");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Number = "..contNum.."|r");
--	end
--	continent = GetContinentName(contNum);
end

function Mounty_Test()
	local WintergraspTimer = 0;
	local ii = GetNumWorldPVPAreas();
	for i=1,ii do
		local pvpID, localizedName, isActive, canQueue, startTime, canEnter = GetWorldPVPAreaInfo(i)
		if isActive then
			WintergraspTimer = 0;
		else
			WintergraspTimer = startTime;
		end
		if localizedName == "Wintergrasp" then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> PvP Zone("..i..") - "..pvpID.." = <"..localizedName.."> @ "..WintergraspTimer.."|r");
		end
	end
	return WintergraspTimer;
end
--]]  ---------------------- Block Remark END

function Mounty_Language(msg, language)
	language = strlower(language);
	lang = {};
	langlow = {};
	index = 0;
	ii = GetNumLanguages();
	for i=1,ii do
		l,n = GetLanguageByIndex(i);
		lang[l] = n;
		l = strlower(l);
		langlow[l] = n;
		if (l == language) then index = n; end
	end
	if (index > 0) then
		SendChatMessage(msg, "YELL", index);
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000 NO SUCH LANGUAGE|r");
	end
end

function Mounty_Test()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> TEST|r");
-------------
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff |r");
--   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffError Sound File = |r|cff00ff00"..MOUNTY_ErrorSound.."|r");
 	Mounty_Sound("error");
 --	CastSpellByName("Swift Flight Form");
	for i in pairs(ChatTypeInfo) do   -- Enable All ColorNameByClass
	    SetChatColorNameByClass(i,1)
	end
--	local class, classFileName = UnitClass("player");
--	local color = RAID_CLASS_COLORS[classFileName];
--	ChatFrame1:AddMessage(class, color.r, color.g, color.b);
--	DEFAULT_CHAT_FRAME:AddMessage(class, color.r, color.g, color.b);
--	DEFAULT_CHAT_FRAME:AddMessage(class, color.r, color.g, color.b);
--	DEFAULT_CHAT_FRAME:AddMessage(Mounty.Class, Mounty.ClassColor.r, Mounty.ClassColor.g, Mounty.ClassColor.b);
--	DEFAULT_CHAT_FRAME:AddMessage(Mounty.Realm);
--	DEFAULT_CHAT_FRAME:AddMessage(Mounty.RealmID);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Version =|r"..MOUNTY_VERSION);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Interface Value =|r"..MOUNTY_INTERFACE);
--	if(MOUNTY_INTERFACE < 60000) then
--		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> TRUE|r");
--	else
--		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> FALSE|r");
--	end
--[[
	local sversion, build, builddate, tocversion = GetBuildInfo();
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Version String (clean)= |r"..sversion);
	local version = tonumber(string.sub(string.gsub(sversion, "%.", ""), 1, 2));
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Version Value = |r"..version);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Build = |r"..build);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Build Date = |r"..builddate);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> TOC Version = |r"..tocversion);
	local z = string.sub(string.gsub(sversion, "%.", ""), 1, 2);
	local y = string.sub(z, 1, 1);
	local x = string.sub(z, 2, -1);
	local ptocversion = "y0x00";
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> z = |r"..z);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> y = |r"..y);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> x = |r"..x);
	ptocversion = string.gsub("y0x00", "y", y)
	ptocversion = string.gsub(ptocversion, "x", x)
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> TOC Version = |r"..ptocversion);
--]]
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> TOC Version = |r"..MOUNTY_TOC);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> TOC Version = |r"..MOUNTY_WOWTOC);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Build = |r"..MOUNTY_BUILD);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Program> Build = |r"..MOUNTY_WOWBUILD);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Faction = |r"..Mounty.Faction);
--	Mounty_PrintAddOnInfo();
----------------------------
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff |r");
	Mounty_SetFlyable();
	Mounty_PrintSilverDollar();
	Mounty_PrintContinents();
	Mounty_SetStateVariables(State);
	if(IsOutdoors()) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Is Outdoors.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff6600Is NOT Outdoors.|r");
	end
	if(State.IsMounted) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Is Mounted.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff6600Is NOT Mounted.|r");
	end		
	if CanExitVehicle() then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Can Exit Vehicle.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff6600Can NOT Exit Vehicle.|r");
	end
	a = "Wor\'var Demolisher";
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff |r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff"..a.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Zone = "..MOUNTY_ZONE.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> VASHJ_TEXT = "..MOUNTY_VASHJ_TEXT.."|r");
	if (MOUNTY_VASHJ_FLAG) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_VASHJ_FLAG = TRUE|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_VASHJ_FLAG = FALSE|r");
	end
	if MOUNTY_SWIMFLAG then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> IS Swimming|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Is NOT Swimming|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Faction = "..Mounty.Faction.."|r");
	
	Mounty_PrintFactionMount();
	if Ability.Skill.Special then 
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00Using SPECIAL Mount Ability.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NOT Using SPECIAL Mount Ability.|r");
	end
	
	
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> END TEST|r");
end

function Mounty_PrintAddOnInfo()
	for i = 1, GetNumAddOns() do
		local addonName, title, notes, enabled, loadable, reason, security = GetAddOnInfo(i);
		if enabled then DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffIndex = "..i.." => "..addonName.."|r"); end
	end
end

function Mounty_PrintContinents()
--[[
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> --- Start Continent Printout ---|r");
	local index = GetCurrentMapContinent();
	local currentName = "Cosmic map";
--	for n = 1, 14 do
--		c = select(n, GetMapContinents());
	cc = {GetMapContinents()};
	for n,c in pairs(cc) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent Index = "..n.."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffOriginal..Name = "..c.."|r");
		c = Mounty_603Continent(c);
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffConverted.Name = "..c.."|r");
		if(index == n) then
			currentName = c;
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Current Continent  = "..currentName.."|r");
		end
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00<Mounty> Current Continent = "..currentName.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00<Mounty> Current Index = "..index.."|r");
	zz = {GetMapZones(index)};
	if(index == 7) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> ----- Start Zone Printout -----|r");
		for n,z in pairs(zz) do
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Zone Index = "..n.."|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffOriginal..Name = "..z.."|r");
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
		end
		zz = nil;
		zz = {"Ashran", "Frostfire Ridge", "Gorgrond", "Spires of Arak", "Shadowmoon Valley", "Nagrand", "Talador", "Tanaan Jungle"};
		n = GetCurrentMapZone();
		z = zz[n];
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Current Index = "..n.."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffCurrent Zone = "..z.."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
	end
--]]	
--[[
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> --- Begin New Zone Printout ---|r");
	MOUNTY_TEST();
	local mapArray = MOUNTY.MAP;
	for n,c in pairs(mapArray) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Index = "..n.."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffffName = "..c[0].."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
	end
	local contNum = GetCurrentMapContinent();
	local zoneNum = GetCurrentMapZone();
	local continent = mapArray[contNum][0];
	local zone = mapArray[contNum][zoneNum];
	for z,zz in pairs(mapArray[contNum]) do
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Index "..z.." = "..zz.."|r");
	end
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
--	local temp = {GetMapZones(contNum)};
--	for z,zz in pairs(temp) do
--		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Index "..z.." = "..zz.."|r");
--	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent Index = "..contNum.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent Name = "..continent.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Zone Index = "..zoneNum.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Zone Name = "..zone.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Real Zone Text = "..GetRealZoneText().."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00MiniMap Zone Text = "..GetMinimapZoneText().."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Sub-Zone Text = "..GetSubZoneText().."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00------------------------------------------------|r");
	contNum, continent, zoneNum, zone = Mounty_GetMapZone(MOUNTY.MAP, MOUNTY.AddMap);
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00------------------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent Index = "..contNum.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent Name = "..continent.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Zone Index = "..zoneNum.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Zone Name = "..zone.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00------------------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00------------------------------------------------|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> --- End Continent/Zone Printout ---|r");
--]]
--	for n,c in pairs(continent) do
--		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Number = "..n.."|r");
--		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Name = "..c.."|r");
--	end
end

function Mounty_PrintSilverDollar()
	local buildingID;
--	local spellName = "Silver Dollar Club";
--	local skillType, spellId = GetSpellBookItemInfo(spellName);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 skillType = |r|cff00ff00"..skillType.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 spellId    = |r|cff00ff00"..spellId.."|r");
--	local name, rank = GetSpellInfo(spellId);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 name      = |r|cff00ff00"..name.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 rank       = |r|cff00ff00"..rank.."|r");
--	local Name, Subtext = GetSpellBookItemName(spellName);
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 Name      = |r|cff00ff00"..Name.."|r");
--	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cff88ffff"..spellName.."|r|cffffff00 Subtext   = |r|cff00ff00"..Subtext.."|r");
	GARRISON_Buildings = nil;
	local buildID = -1;
	local rank = nil;
	GARRISON_Buildings = C_Garrison.GetBuildings();
	for i,v in pairs(GARRISON_Buildings) do
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffff0000 "..i.." = |r");
		for ii,vv in pairs(v) do
			local s = nil;
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffffff00 "..ii.." = |r|cff00ff00"..vv.."|r");
			local s = string.find(v.texPrefix, "Stables");
			if(s) then buildID = v.buildingID; end
		end
	end
	if(buildID < 0) then
		Ability.printout.Stables = 0;
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffff8800 Your Stables are at Level = |r|cffff0000"..Ability.printout.Stables.."|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffffff00 Building ID = "..buildID.."|r");
		local buildingID, buildingName, texturePrefix, icon, description, rank, currencyID, currencyAmount, goldAmount, timeRequirement, needsPlan, isPreBuilt, possSpecs, upgrades, canUpgrade, isMaxLevel, hasFollowerSlot = C_Garrison.GetBuildingInfo(buildID);
		Ability.printout.Stables = rank;
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffffff00 Building ID = "..buildingID.." is at Rank = "..rank.."|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> |r|cffffff00 Your Stables are at Level = |r|cff00ff00"..Ability.printout.Stables.."|r");
	end
	if(Ability.printout.Stables == 3) then 
		Ability.Skill.Stables = true;
	end
end

